//============================================================================
// d_vgm.c
//============================================================================
// VGḾEhCuB
//============================================================================

#include "d_vgm.h"
#include <stdio.h>
#include <stdlib.h>

//#define USE_ZLI 1

#ifdef USE_ZLI

#include "zlib/include/zlib.h"
#pragma warning(disable : 4996)

#endif

#ifdef __cplusplus
extern "C" {
#endif


static Uint8 *dat = 0;			//ǂݍVGMf[^
static Uint32 size;			//VGMt@C̃TCY
static Uint32 clock[DEV__EOF];	//`bṽNbN
static Uint32 version;			//VGMo[W
static Uint8 *gd3;				//GD3̂Ƃ
static Uint32 maxsample;		//TvPʂł̃f[^
static Uint8 *looppos;			//[vJnʒu
static Uint32 loopsample;		//[v镪̃Tv
static Uint32 rate;			//NTSC/PAL[g
static Uint8 *vgm;				//VGMf[^
static Uint32 sn76489dt;		//SN76489ڍ
static Double wait;			//̖߂܂ł̃EFCg imsPʁj
static Uint8 *vgmmax;			//VGMf[^̖
static Uint8 *pos;				//ǂłꏊ
static Uint32 sec;				//Đb

#define P2U32(x) (*((Uint32 *)(x)))


void VGMDclose(){
	if(dat){
		free(dat);
		dat = 0;
		pos = 0;
	}
}

/*
------------------------------------------------------------------------------
VGMHeaderRead
------------------------------------------------------------------------------
wb_
------------------------------------------------------------------------------
߂lF
@0 
@1 t@Cʈُ
@2 t@Cُ
------------------------------------------------------------------------------
*/
Uint8 VGMHeaderRead(){
	Uint32 hsize, bf;
	//00-03 "Vgm "
	if(dat[0x00]!='V'
	|| dat[0x01]!='g'
	|| dat[0x02]!='m'
	|| dat[0x03]!=' '){
		//擪f[^ĂꍇA͈Ⴄt@CG[
		return 1;
	}
	
	//04-07 t@CTCY-4
	//ĂB

	//08-0B VGMo[W
	version = P2U32(dat+0x08);

	//0C-0F SN76489NbN
	clock[DEV_SN76489] = P2U32(dat+0x0c);

	//10-13 YM2413NbN
	clock[DEV_YM2413] = P2U32(dat+0x0c);

	//14-17 GD3ItZbgi0x14 + nj
	bf = P2U32(dat+0x14);
	if(bf){
		gd3 = dat + 0x14 + bf;
		vgmmax = gd3-1;
	}else{
		gd3 = 0;
		vgmmax = dat + size-1;
	}

	//18-1B TvPʂł̃f[^
	maxsample = P2U32(dat+0x18);
	
	//1C-1F [vJnʒui0x1C + nj
	bf = P2U32(dat+0x1c);
	if(bf){
		looppos = dat + 0x1c + bf;
	}else{
		looppos = 0;
	}

	//20-23 [v镪̃Tv
	loopsample = P2U32(dat+0x20);

	//24-27 [V1.01-]NTSC/PAL[g
	maxsample = P2U32(dat+0x24);

	//28-29 [V1.10-]SN76489mCYtB[hobNl
	//2A    [V1.10-]SN76489mCYWX^rbg
	//2B    [V1.51-]SN76489ڍ
	//@@@߂ǂ̂łԂЂƂ܂Ƃ߂ɓB
	sn76489dt = P2U32(dat+0x28);
	if(!sn76489dt) sn76489dt = 0x00100009;

	//2C-2F [V1.10-]YM2612NbN
	clock[DEV_YM2612] = P2U32(dat+0x0c);

	//30-33 [V1.10-]YM2151NbN
	clock[DEV_YM2151] = P2U32(dat+0x0c);

	//34-37 [V1.50-]VGMwb_TCYi0x34 + nj
	hsize = P2U32(dat+0x34);
	if(!hsize) hsize = 0x0c;
	hsize += 0x34;

	//38-3B [V1.51-]SegaPCMNbN
	clock[DEV_SEGAPCM] = P2U32(dat+0x38);

	//3C-3F [V1.51-]SegaPCM Interface Register
	//悭Ȃ̂œǂݔ΂BG~[^B

	if(version < 0x150){
		vgm = dat + 0x40;
		return 0;
	}
	vgm = dat + hsize;
/*
	DEV_RF5C68,
	DEV_YM2203,
	DEV_YM2608,
	DEV_YM2610,
	DEV_YM3812,
	DEV_YM3526,
	DEV_Y8950,
	DEV_YMF262,
	DEV_YMF278B,
	DEV_YMF271,
	DEV_YMZ280B,
	DEV_RF5C164,
	DEV_PWM,
	DEV_AY8910,
	DEV_DMG,
	DEV_RP2A03,
	DEV_MULTIPCM,
	DEV_UPD7759,
	DEV_OKIM6258,
	DEV_OKIM6295,
	DEV_K051649,
	DEV_K054539,
	DEV_HUC6280,
	DEV_C140,
	DEV_K053260,
	DEV_POKEY,
	DEV_QSOUND,
	DEV_SCSP,
*/
	return 0;

}


/*
------------------------------------------------------------------------------
VGMDOpen
------------------------------------------------------------------------------
t@CI[vāAɓǂݍ
------------------------------------------------------------------------------
F
  char *file	t@CpX
------------------------------------------------------------------------------
߂lF
@0 
@1 t@CI[vs
@2 t@Cُ
------------------------------------------------------------------------------
*/
Uint8 VGMDopen(char *file){
	FILE *fi;
#ifdef USE_ZLI
	if((file[strlen(file)-1] & 0xbf) == 'Z'){
		//VGZ
		gzopen(
	}else
#endif
	{
		//VGM
		fi = fopen(file,"rb");
		if(fi){
			fseek(fi,0,SEEK_END);
			size = ftell(fi)+1;
			VGMDclose();
			dat = malloc(size);
			fseek(fi,0,SEEK_SET);
			fread(dat,size,1,fi);
			fclose(fi);

			//wb_͕͂ʊ֐ɔC
			if(VGMHeaderRead()){
				//ꍇ͉ăG[ɂ
				VGMDclose();
				return 2;
			}else{
				return 0;
			}
		}
		return 1;
	}
}


Uint8 VGMDstart(Uint32 num){
	wait = 0;
	pos = vgm;
	sec = 0;
	rvs_reset();
}

Uint8 VGMDstop(){
	wait = 0;
	rvs_reset();
}

/*
------------------------------------------------------------------------------
VGMDinfo
------------------------------------------------------------------------------
[J֐ info]
VGMĐ擾B
------------------------------------------------------------------------------
F
  Uint32 rq   NGXgԍ
  Char* str   i[
------------------------------------------------------------------------------
߂lFNGXgԍɂB
------------------------------------------------------------------------------
*/
Uint32 VGMDinfo(Uint32 rq, Char* str){
	switch(rq){
		case 1:
		//t@C\
		//----------------------------------------------------------------
		//strɂ500oCg̃wB
		//߂l0
		//----------------------------------------------------------------
			sprintf(str,"[VGM]\r\n"
				);

			return 0;

		case 2:
		//őȐ\
		//----------------------------------------------------------------
		//strɂNULLł
		//߂l͑I\ȋȐ
		//----------------------------------------------------------------
			return 0;

		case 10:
		//Xe[^Xo[ɕ\镶
		//----------------------------------------------------------------
		//strɂ100oCg̃wB
		//߂l0
		//----------------------------------------------------------------
			sprintf(str,"[VGM] %05d.%05d %06X[%06X-%06X]"
				,sec/44100,sec%44100,pos-dat,looppos?looppos-dat:0,vgmmax-dat);
			return 0;
	}
	return 0;
}

/*
------------------------------------------------------------------------------
VGMDdrive
------------------------------------------------------------------------------
[J֐ drive]
VGM͂B
xĂԂƂŁAVGMĐB
------------------------------------------------------------------------------
F
  Double addt   AddTimeŁAi߂鎞Ԃ~bŎwB
------------------------------------------------------------------------------
߂lF̏܂ł̃EFCgԂԂ
@@@@ĐIĂ-1Ԃ
------------------------------------------------------------------------------
*/
Double VGMDdrive(Double addt){
	Uint32 i;
	if(!pos)return 1;
	wait -= addt;
	while(wait < 0){
		do{
			switch(*pos){
				case 0x4F: //dd    : Game Gear PSG stereo, write dd to port 0x06
					pos+=2;
					break;
				case 0x50: //dd    : PSG (SN76489/SN76496) write value dd
					rvs_push(DEVIF_SN76489, 0, 0, 0, *(pos+1));pos+=2;
					break;
				case 0x51: //aa dd : YM2413, write value dd to register aa
					rvs_push(DEVIF_YM2413, 0, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x52: //aa dd : YM2612 port 0, write value dd to register aa
				case 0x53: //aa dd : YM2612 port 1, write value dd to register aa
					rvs_push(DEVIF_YM2612, 0, *(pos+0)-0x52, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x54: //aa dd : YM2151, write value dd to register aa
					rvs_push(DEVIF_YM2151, 0, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x55: //aa dd : YM2203, write value dd to register aa
					rvs_push(DEVIF_YM2203, 0, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x56: //aa dd : YM2608 port 0, write value dd to register aa
				case 0x57: //aa dd : YM2608 port 1, write value dd to register aa
					rvs_push(DEVIF_YM2608, 0, *(pos+0)-0x56, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x58: //aa dd : YM2610 port 0, write value dd to register aa
				case 0x59: //aa dd : YM2610 port 1, write value dd to register aa
					rvs_push(DEVIF_YM2610, 0, *(pos+0)-0x58, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x5A: //aa dd : YM3812, write value dd to register aa
					rvs_push(DEVIF_YM3812, 0, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x5B: //aa dd : YM3526, write value dd to register aa
					rvs_push(DEVIF_YM3526, 0, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x5C: //aa dd : Y8950, write value dd to register aa
					rvs_push(DEVIF_Y8950, 0, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x5D: //aa dd : YMZ280B, write value dd to register aa
					pos+=3;
					break;
				case 0x5E: //aa dd : YMF262 port 0, write value dd to register aa
				case 0x5F: //aa dd : YMF262 port 1, write value dd to register aa
					rvs_push(DEVIF_YMF262, 0, *(pos+0)-0x5E, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0x61: //nn nn : Wait n samples
					i = (*(pos+1) | (*(pos+2) << 8));
					sec += i;
					wait += i * (1000.0/44100.0);
					if(i>300){
						rvs_send();
					}
					pos+=3;
					break;
				case 0x62: //      : wait 735 samples (60th of a second) = 0x61 0xdf 0x02
					wait += 735 * (1000.0/44100.0);
					sec += 735;
					pos++;
					rvs_send();
					break;
				case 0x63: //      : wait 882 samples (50th of a second) = 0x61 0x72 0x03
					wait += 882 * (1000.0/44100.0);
					sec += 882;
					pos++;
					rvs_send();
					break;
				case 0x64: //cc nn nn : override length of 0x62/0x63
					//ȂėǂB
					pos++;
					break;

				case 0x66: //      : end of sound data
					//[vȂ烋[v܂傤B΃XgbvB
					if(looppos){
						pos = looppos;
					}else{
						//VGMDstop();
						wait = 0;
						return -1;
					}
					break;

				case 0x67: //...   : data block
					pos++;
					break;
				case 0x68: //...   : PCM RAM write
					pos++;
					break;

				case 0x70:
				case 0x71:
				case 0x72:
				case 0x73:
				case 0x74:
				case 0x75:
				case 0x76:
				case 0x77:
				case 0x78:
				case 0x79:
				case 0x7A:
				case 0x7B:
				case 0x7C:
				case 0x7D:
				case 0x7E:
				case 0x7F: //7n    : wait n+1 samples, n can range from 0 to 15.
					i = ((*pos++ & 0x0f)+1);
					wait += i * (1000.0/44100.0);
					sec += i;
					break;

				case 0x80:
				case 0x81:
				case 0x82:
				case 0x83:
				case 0x84:
				case 0x85:
				case 0x86:
				case 0x87:
				case 0x88:
				case 0x89:
				case 0x8A:
				case 0x8B:
				case 0x8C:
				case 0x8D:
				case 0x8E:
				case 0x8F: //8n    : YM2612 port 0 address 2A + wait n samples
					i = ((*pos++ & 0x0f)+0);
					wait += i * (1000.0/44100.0);
					sec += i;
					break;

				//case 0x90: //0x95  : DAC Stream Control Write: see below
				case 0xA0: //aa dd : AY8910, write value dd to register aa
					rvs_push(DEVIF_AY8910, 0, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0xA5: //aa dd : YM2203, write value dd to register aa
					rvs_push(DEVIF_YM2203, 1, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0xB0: //aa dd : RF5C68, write value dd to register aa
				case 0xB1: //aa dd : RF5C164, write value dd to register aa
				case 0xB2: //ad dd : PWM, write value ddd to register a (d is MSB, dd is LSB)
				case 0xB3: //aa dd : GameBoy DMG, write value dd to register aa
				case 0xB4: //aa dd : NES APU, write value dd to register aa
				case 0xB5: //aa dd : MultiPCM, write value dd to register aa
				case 0xB6: //aa dd : uPD7759, write value dd to register aa
				case 0xB7: //aa dd : OKIM6258, write value dd to register aa
				case 0xB8: //aa dd : OKIM6295, write value dd to register aa
				case 0xB9: //aa dd : HuC6280, write value dd to register aa
				case 0xBA: //aa dd : K053260, write value dd to register aa
					pos+=3;
					break;
				case 0xBB: //aa dd : Pokey, write value dd to register aa
					rvs_push(DEVIF_POKEY, 0, 0, *(pos+1), *(pos+2));pos+=3;
					break;
				case 0xC0: //aaaa dd : Sega PCM, write value dd to memory offset aaaa
				case 0xC1: //aaaa dd : RF5C68, write value dd to memory offset aaaa
				case 0xC2: //aaaa dd : RF5C164, write value dd to memory offset aaaa
				case 0xC3: //cc aaaa : MultiPCM, write set bank offset aaaa to channel cc
				case 0xC4: //mmll rr : QSound, write value mmll to register rr
				case 0xC5: //mmll dd : SCSP, write value dd to memory offset mmll
					pos+=4;
					break;
				case 0xD0: //pp aa dd : YMF278B port pp, write value dd to register aa
					rvs_push(DEVIF_YMF278B, 0, *(pos+1), *(pos+2), *(pos+3));pos+=4;
					break;
				case 0xD1: //pp aa dd : YMF271 port pp, write value dd to register aa
					rvs_push(DEVIF_YMF271, 0, *(pos+1), *(pos+2), *(pos+3));pos+=4;
					break;
				case 0xD2: //pp aa dd : SCC1 port pp, write value dd to register aa
				case 0xD3: //pp aa dd : K054539 write value dd to register ppaa
				case 0xD4: //pp aa dd : C140 write value dd to register ppaa
					pos+=4;
					break;
				case 0xE0: //dddddddd : seek to offset dddddddd (Intel byte order) in PCM data bank
					pos+=5;
					break;

				default:
					pos++;
					break;
			}
		}while(
			(*pos >= 0x61 && *pos <= 0x63 ) ||
			(*pos >= 0x70 && *pos <= 0x7F )
		);
	}
	rvs_send();
	return wait;
}

Uint8 d_vgm_new(DECODE_INTERFACE *i){
	i->open  = *VGMDopen;
	i->close = *VGMDclose;
	i->start = *VGMDstart;
	i->stop  = *VGMDstop;
	i->drive = *VGMDdrive;
	i->info  = *VGMDinfo;
	if(dat){
		VGMDclose();
	}
	dat = 0;
	pos = 0;

	return 0;
}

#ifdef __cplusplus
}
#endif